| NANO100_BSP V3.05.000 The Board Support Package for Nano100BN Series

Macros | Functions
UART Exported Functions
NANO100 Device Driver » UART Driver » UART Exported Constants
Collaboration diagram for UART Exported Functions:

## Macros
#define | UART_BAUD_MODE0 (0)
| Calculate UART baudrate mode0 divider. More...
#define | UART_BAUD_MODE1 (UART_BAUD_DIV_16_EN_Msk)
| Calculate UART baudrate mode0 divider. More...
#define | UART_BAUD_MODE1_DIVIDER(u32SrcFreq, u32BaudRate) (((u32SrcFreq + (u32BaudRate*8)) / u32BaudRate >> 4)-1)
| Calculate UART baudrate mode0 divider. More...
#define | UART_BAUD_MODE0_DIVIDER(u32SrcFreq, u32BaudRate) (((u32SrcFreq + (u32BaudRate/2)) / u32BaudRate)-1)
| Calculate UART baudrate mode2 divider. More...
#define | UART_WRITE(uart, u8Data) (uart->THR = (u8Data))
| Write Data to Tx data register. More...
#define | UART_READ(uart) (uart->RBR)
| Read Rx data register. More...
#define | UART_GET_TX_EMPTY(uart) (uart->FSR & UART_FSR_TX_EMPTY_F_Msk)
| Get Tx empty register value. More...
#define | UART_GET_RX_EMPTY(uart) (uart->FSR & UART_FSR_RX_EMPTY_F_Msk)
| Get Rx empty register value. More...
#define | UART_IS_TX_EMPTY(uart) ((uart->FSR & UART_FSR_TE_F_Msk) >> UART_FSR_TE_F_Pos)
| Check specified uart port transmission is over. More...
#define | UART_WAIT_TX_EMPTY(uart) while(!(((uart->FSR) & UART_FSR_TX_EMPTY_F_Msk) >> UART_FSR_TX_EMPTY_F_Pos))
| Wait specified uart port transmission is over. More...
#define | UART_IS_RX_READY(uart) ((uart->ISR & UART_ISR_RDA_IS_Msk)>>UART_ISR_RDA_IS_Pos)
| Check RDA_IF is set or not. More...
#define | UART_IS_TX_FULL(uart) ((uart->FSR & UART_FSR_TX_FULL_F_Msk)>>UART_FSR_TX_FULL_F_Pos)
| Check TX FIFO is full or not. More...
#define | UART_IS_RX_FULL(uart) ((uart->FSR & UART_FSR_RX_FULL_F_Msk)>>UART_FSR_RX_FULL_F_Pos)
| Check RX FIFO is full or not. More...
#define | UART_GET_TX_FULL(uart) (uart->FSR & UART_FSR_TX_FULL_F_Msk)
| Get Tx full register value. More...
#define | UART_GET_RX_FULL(uart) (uart->FSR & UART_FSR_RX_FULL_F_Msk)
| Get Rx full register value. More...
#define | UART_ENABLE_INT(uart, u32eIntSel) (uart->IER |= (u32eIntSel))
| Enable specified interrupt. More...
#define | UART_DISABLE_INT(uart, u32eIntSel) (uart->IER &= ~ (u32eIntSel))
| Disable specified interrupt. More...
#define | UART_GET_INT_FLAG(uart, u32eIntTypeFlag) ((uart->ISR & (u32eIntTypeFlag))?1:0)
| Get specified interrupt flag/status. More...
#define | UART_RS485_CLEAR_ADDR_FLAG(uart) (uart->TRSR |= UART_TRSR_RS485_ADDET_F_Msk)
| Clear RS-485 Address Byte Detection Flag. More...
#define | UART_RS485_GET_ADDR_FLAG(uart) ((uart->TRSR & UART_TRSR_RS485_ADDET_F_Msk) >> UART_TRSR_RS485_ADDET_F_Pos)
| Get RS-485 Address Byte Detection Flag. More...

## Functions
static __INLINE void | UART_CLEAR_RTS (UART_T *uart)
| Set RTS pin is low. More...
static __INLINE void | UART_SET_RTS (UART_T *uart)
| Set RTS pin is high. More...
void | UART_ClearIntFlag (UART_T *uart, uint32_t u32InterruptFlag)
| The function is used to clear UART specified interrupt flag. More...
void | UART_Close (UART_T *uart)
| The function is used to disable UART. More...
void | UART_DisableFlowCtrl (UART_T *uart)
| The function is used to disable UART auto flow control. More...
void | UART_DisableInt (UART_T *uart, uint32_t u32InterruptFlag)
| The function is used to disable UART specified interrupt and disable NVIC UART IRQ. More...
void | UART_EnableFlowCtrl (UART_T *uart)
| The function is used to Enable UART auto flow control. More...
void | UART_EnableInt (UART_T *uart, uint32_t u32InterruptFlag)
| The function is used to enable UART specified interrupt and disable NVIC UART IRQ. More...
void | UART_Open (UART_T *uart, uint32_t u32baudrate)
| This function use to enable UART function and set baud-rate. More...
uint32_t | UART_Read (UART_T *uart, uint8_t *pu8RxBuf, uint32_t u32ReadBytes)
| The function is used to read Rx data from RX FIFO and the data will be stored in pu8RxBuf. More...
void | UART_SetLine_Config (UART_T *uart, uint32_t u32baudrate, uint32_t u32data_width, uint32_t u32parity, uint32_t u32stop_bits)
| This function use to config UART line setting. More...
void | UART_SetTimeoutCnt (UART_T *uart, uint32_t u32TOC)
| This function use to set Rx timeout count. More...
void | UART_SelectIrDAMode (UART_T *uart, uint32_t u32Buadrate, uint32_t u32Direction)
| The function is used to configure IrDA relative settings. It consists of TX or RX mode and baudrate. More...
void | UART_SelectRS485Mode (UART_T *uart, uint32_t u32Mode, uint32_t u32Addr)
| The function is used to set RS485 relative setting. More...
void | UART_SelectLINMode (UART_T *uart, uint32_t u32Mode, uint32_t u32BreakLength)
| Select and configure LIN function. More...
uint32_t | UART_Write (UART_T *uart, uint8_t *pu8TxBuf, uint32_t u32WriteBytes)
| The function is to write data into TX buffer to transmit data by UART. More...

## Detailed Description

## Macro Definition Documentation

## ◆ UART_BAUD_MODE0

#define UART_BAUD_MODE0 (0)

Calculate UART baudrate mode0 divider.

Parameters

  None |

Returns
  UART baudrate mode0 register setting value

Definition at line 94 of file uart.h.

## ◆ UART_BAUD_MODE0_DIVIDER

#define UART_BAUD_MODE0_DIVIDER | ( |  | u32SrcFreq,
|  |  | u32BaudRate
| ) |  | (((u32SrcFreq + (u32BaudRate/2)) / u32BaudRate)-1)

Calculate UART baudrate mode2 divider.

Parameters

  [in] | u32SrcFreq | UART clock frequency
  [in] | u32BaudRate | Baudrate of UART module

Returns
  UART baudrate mode0 divider

Definition at line 126 of file uart.h.

## ◆ UART_BAUD_MODE1

#define UART_BAUD_MODE1 (UART_BAUD_DIV_16_EN_Msk)

Calculate UART baudrate mode0 divider.

Parameters

  None |

Returns
  UART baudrate mode1 register setting value

Definition at line 104 of file uart.h.

## ◆ UART_BAUD_MODE1_DIVIDER

#define UART_BAUD_MODE1_DIVIDER | ( |  | u32SrcFreq,
|  |  | u32BaudRate
| ) |  | (((u32SrcFreq + (u32BaudRate*8)) / u32BaudRate >> 4)-1)

Calculate UART baudrate mode0 divider.

Parameters

  [in] | u32SrcFreq | UART clock frequency
  [in] | u32BaudRate | Baudrate of UART module

Returns
  UART baudrate mode1 divider

Definition at line 116 of file uart.h.

## ◆ UART_DISABLE_INT

#define UART_DISABLE_INT | ( |  | uart,
|  |  | u32eIntSel
| ) |  | (uart->IER &= ~ (u32eIntSel))

Disable specified interrupt.

Parameters

  [in] | uart | The base address of UART module
  [in] | u32eIntSel | Interrupt type select UART_IER_LIN_IE_Msk : LIN interrupt UART_IER_ABAUD_IE_Msk : Auto baudrate interrupt UART_IER_WAKE_IE_Msk : Wakeup interrupt UART_IER_BUF_ERR_IE_Msk : Buffer Error interrupt UART_IER_RTO_IE_Msk : Rx time-out interrupt UART_IER_MODEM_IE_Msk : Modem interrupt UART_IER_RLS_IE_Msk : Rx Line status interrupt UART_IER_THRE_IE_Msk : Tx empty interrupt UART_IER_RDA_IE_Msk : Rx ready interrupt

Returns
  None

Definition at line 279 of file uart.h.

## ◆ UART_ENABLE_INT

#define UART_ENABLE_INT | ( |  | uart,
|  |  | u32eIntSel
| ) |  | (uart->IER |= (u32eIntSel))

Enable specified interrupt.

Parameters

  [in] | uart | The base address of UART module
  [in] | u32eIntSel | Interrupt type select UART_IER_LIN_IE_Msk : LIN interrupt UART_IER_ABAUD_IE_Msk : Auto baudrate interrupt UART_IER_WAKE_IE_Msk : Wakeup interrupt UART_IER_BUF_ERR_IE_Msk : Buffer Error interrupt UART_IER_RTO_IE_Msk : Rx time-out interrupt UART_IER_MODEM_IE_Msk : Modem interrupt UART_IER_RLS_IE_Msk : Rx Line status interrupt UART_IER_THRE_IE_Msk : Tx empty interrupt UART_IER_RDA_IE_Msk : Rx ready interrupt

Returns
  None

Definition at line 260 of file uart.h.

## ◆ UART_GET_INT_FLAG

#define UART_GET_INT_FLAG | ( |  | uart,
|  |  | u32eIntTypeFlag
| ) |  | ((uart->ISR & (u32eIntTypeFlag))?1:0)

Get specified interrupt flag/status.

Parameters

  [in] | uart | The base address of UART module
  [in] | u32eIntTypeFlag | Interrupt Type Flag,should be UART_ISR_LIN_IS_Msk : LIN interrupt flag UART_ISR_ABAUD_IS_Msk : Auto baudrate interrupt flag UART_ISR_WAKE_IS_Msk : Wakeup interrupt flag UART_ISR_BUF_ERR_IS_Msk : Buffer Error interrupt flag UART_ISR_RTO_IS_Msk : Rx time-out interrupt flag UART_ISR_MODEM_IS_Msk : Modem interrupt flag UART_ISR_RLS_IS_Msk : Rx Line status interrupt flag UART_ISR_THRE_IS_Msk : Tx empty interrupt flag UART_ISR_RDA_IS_Msk : Rx ready interrupt flag

Returns
  0 = The specified interrupt is not happened. 1 = The specified interrupt is happened.

Definition at line 301 of file uart.h.

## ◆ UART_GET_RX_EMPTY

#define UART_GET_RX_EMPTY | ( |  | uart | ) | (uart->FSR & UART_FSR_RX_EMPTY_F_Msk)

Get Rx empty register value.

Parameters

  [in] | uart | The base address of UART module

Returns
  Rx empty register value.

Definition at line 166 of file uart.h.

## ◆ UART_GET_RX_FULL

#define UART_GET_RX_FULL | ( |  | uart | ) | (uart->FSR & UART_FSR_RX_FULL_F_Msk)

Get Rx full register value.

Parameters

  [in] | uart | The base address of UART module

Returns
  Rx full register value

Definition at line 240 of file uart.h.

## ◆ UART_GET_TX_EMPTY

#define UART_GET_TX_EMPTY | ( |  | uart | ) | (uart->FSR & UART_FSR_TX_EMPTY_F_Msk)

Get Tx empty register value.

Parameters

  [in] | uart | The base address of UART module

Returns
  Tx empty register value.

Definition at line 156 of file uart.h.

## ◆ UART_GET_TX_FULL

#define UART_GET_TX_FULL | ( |  | uart | ) | (uart->FSR & UART_FSR_TX_FULL_F_Msk)

Get Tx full register value.

Parameters

  [in] | uart | The base address of UART module

Returns
  Tx full register value

Definition at line 230 of file uart.h.

## ◆ UART_IS_RX_FULL

#define UART_IS_RX_FULL | ( |  | uart | ) | ((uart->FSR & UART_FSR_RX_FULL_F_Msk)>>UART_FSR_RX_FULL_F_Pos)

Check RX FIFO is full or not.

Parameters

  [in] | uart | The base address of UART module

Returns
  1 = RX FIFO is full 0 = RX FIFO is not full

Definition at line 220 of file uart.h.

## ◆ UART_IS_RX_READY

#define UART_IS_RX_READY | ( |  | uart | ) | ((uart->ISR & UART_ISR_RDA_IS_Msk)>>UART_ISR_RDA_IS_Pos)

Check RDA_IF is set or not.

Parameters

  [in] | uart | The base address of UART module

Returns
  0 : The number of bytes in the RX FIFO is less than the RFITL 1 : The number of bytes in the RX FIFO equals or larger than RFITL

Definition at line 196 of file uart.h.

## ◆ UART_IS_TX_EMPTY

#define UART_IS_TX_EMPTY | ( |  | uart | ) | ((uart->FSR & UART_FSR_TE_F_Msk) >> UART_FSR_TE_F_Pos)

Check specified uart port transmission is over.

Parameters

  [in] | uart | The base address of UART module

Returns
  TE_Flag.

Definition at line 175 of file uart.h.

## ◆ UART_IS_TX_FULL

#define UART_IS_TX_FULL | ( |  | uart | ) | ((uart->FSR & UART_FSR_TX_FULL_F_Msk)>>UART_FSR_TX_FULL_F_Pos)

Check TX FIFO is full or not.

Parameters

  [in] | uart | The base address of UART module

Returns
  1 = TX FIFO is full 0 = TX FIFO is not full

Definition at line 208 of file uart.h.

## ◆ UART_READ

#define UART_READ | ( |  | uart | ) | (uart->RBR)

Read Rx data register.

Parameters

  [in] | uart | The base address of UART module.

Returns
  The oldest data byte in RX FIFO

Definition at line 146 of file uart.h.

## ◆ UART_RS485_CLEAR_ADDR_FLAG

#define UART_RS485_CLEAR_ADDR_FLAG | ( |  | uart | ) | (uart->TRSR |= UART_TRSR_RS485_ADDET_F_Msk)

Clear RS-485 Address Byte Detection Flag.

Parameters

  [in] | uart | The base address of UART module

Returns
  None

Definition at line 332 of file uart.h.

## ◆ UART_RS485_GET_ADDR_FLAG

#define UART_RS485_GET_ADDR_FLAG | ( |  | uart | ) | ((uart->TRSR & UART_TRSR_RS485_ADDET_F_Msk) >> UART_TRSR_RS485_ADDET_F_Pos)

Get RS-485 Address Byte Detection Flag.

Parameters

  [in] | uart | The base address of UART module

Returns
  RS-485 Address Byte Detection Flag

Definition at line 341 of file uart.h.

## ◆ UART_WAIT_TX_EMPTY

#define UART_WAIT_TX_EMPTY | ( |  | uart | ) | while(!(((uart->FSR) & UART_FSR_TX_EMPTY_F_Msk) >> UART_FSR_TX_EMPTY_F_Pos))

Wait specified uart port transmission is over.

Parameters

  [in] | uart | The base address of UART module

Returns
  None

Definition at line 185 of file uart.h.

## ◆ UART_WRITE

#define UART_WRITE | ( |  | uart,
|  |  | u8Data
| ) |  | (uart->THR = (u8Data))

Write Data to Tx data register.

Parameters

  [in] | uart | The base address of UART module.
  [in] | u8Data | Data byte to transmit

Returns
  None

Definition at line 137 of file uart.h.

## Function Documentation

## ◆ UART_CLEAR_RTS()

static __INLINE void UART_CLEAR_RTS | ( | UART_T * | uart | ) |
| static

Set RTS pin is low.

Parameters

  [in] | uart | The base address of UART module

Returns
  None

Definition at line 310 of file uart.h.

## ◆ UART_ClearIntFlag()

void UART_ClearIntFlag | ( | UART_T * | uart,
|  | uint32_t | u32InterruptFlag
| ) |  |

The function is used to clear UART specified interrupt flag.

Parameters

  [in] | uart | The base address of UART module.
  [in] | u32InterruptFlag | The specified interrupt of UART module..

Returns
  None

Definition at line 41 of file uart.c.

## ◆ UART_Close()

void UART_Close | ( | UART_T * | uart | ) |

The function is used to disable UART.

Parameters

  [in] | uart | The base address of UART module.

Returns
  None

Definition at line 83 of file uart.c.

## ◆ UART_DisableFlowCtrl()

void UART_DisableFlowCtrl | ( | UART_T * | uart | ) |

The function is used to disable UART auto flow control.

Parameters

  [in] | uart | The base address of UART module.

Returns
  None

Definition at line 96 of file uart.c.

## ◆ UART_DisableInt()

void UART_DisableInt | ( | UART_T * | uart,
|  | uint32_t | u32InterruptFlag
| ) |  |

The function is used to disable UART specified interrupt and disable NVIC UART IRQ.

Parameters

  [in] | uart | The base address of UART module.
  [in] | u32InterruptFlag | The specified interrupt of UART module. UART_IER_LIN_IE_Msk : LIN interrupt UART_IER_ABAUD_IE_Msk : Auto baudrate interrupt UART_IER_WAKE_IE_Msk : Wakeup interrupt UART_IER_ABAUD_IE_Msk : Auto Baud-rate interrupt UART_IER_BUF_ERR_IE_Msk : Buffer Error interrupt UART_IER_RTO_IE_Msk : Rx time-out interrupt UART_IER_MODEM_IE_Msk : Modem interrupt UART_IER_RLS_IE_Msk : Rx Line status interrupt UART_IER_THRE_IE_Msk : Tx empty interrupt UART_IER_RDA_IE_Msk : Rx ready interrupt

Returns
  None

Definition at line 120 of file uart.c.

## ◆ UART_EnableFlowCtrl()

void UART_EnableFlowCtrl | ( | UART_T * | uart | ) |

The function is used to Enable UART auto flow control.

Parameters

  [in] | uart | The base address of UART module.

Returns
  None

Definition at line 134 of file uart.c.

## ◆ UART_EnableInt()

void UART_EnableInt | ( | UART_T * | uart,
|  | uint32_t | u32InterruptFlag
| ) |  |

The function is used to enable UART specified interrupt and disable NVIC UART IRQ.

Parameters

  [in] | uart | The base address of UART module.
  [in] | u32InterruptFlag | The specified interrupt of UART module: UART_IER_LIN_IE_Msk : LIN interrupt UART_IER_ABAUD_IE_Msk : Auto baudrate interrupt UART_IER_WAKE_IE_Msk : Wakeup interrupt UART_IER_ABAUD_IE_Msk : Auto Baud-rate interrupt UART_IER_BUF_ERR_IE_Msk : Buffer Error interrupt UART_IER_RTO_IE_Msk : Rx time-out interrupt UART_IER_MODEM_IE_Msk : Modem interrupt UART_IER_RLS_IE_Msk : Rx Line status interrupt UART_IER_THRE_IE_Msk : Tx empty interrupt UART_IER_RDA_IE_Msk : Rx ready interrupt

Returns
  None

Definition at line 159 of file uart.c.

## ◆ UART_Open()

void UART_Open | ( | UART_T * | uart,
|  | uint32_t | u32baudrate
| ) |  |

This function use to enable UART function and set baud-rate.

Parameters

  [in] | uart | The base address of UART module.
  [in] | u32baudrate | The baudrate of UART module.

Returns
  None

Definition at line 173 of file uart.c.

Here is the call graph for this function:

## ◆ UART_Read()

uint32_t UART_Read | ( | UART_T * | uart,
|  | uint8_t * | pu8RxBuf,
|  | uint32_t | u32ReadBytes
| ) |  |

The function is used to read Rx data from RX FIFO and the data will be stored in pu8RxBuf.

Parameters

  [in] | uart | The base address of UART module.
  [out] | pu8RxBuf | The buffer to receive the data of receive FIFO.
  [in] | u32ReadBytes | The the read bytes number of data.

Returns
  u32Count: Receive byte count

Definition at line 222 of file uart.c.

## ◆ UART_SelectIrDAMode()

void UART_SelectIrDAMode | ( | UART_T * | uart,
|  | uint32_t | u32Buadrate,
|  | uint32_t | u32Direction
| ) |  |

The function is used to configure IrDA relative settings. It consists of TX or RX mode and baudrate.

Parameters

  [in] | uart | The base address of UART module.
  [in] | u32Buadrate | The baudrate of UART module.
  [in] | u32Direction | The direction(transmit:1/receive:0) of UART module in IrDA mode.

Returns
  None

Definition at line 317 of file uart.c.

Here is the call graph for this function:

## ◆ UART_SelectLINMode()

void UART_SelectLINMode | ( | UART_T * | uart,
|  | uint32_t | u32Mode,
|  | uint32_t | u32BreakLength
| ) |  |

Select and configure LIN function.

Parameters

  [in] | uart | The pointer of the specified UART module.
  [in] | u32Mode | The LIN direction : UART_ALT_CTL_LIN_TX_EN_Msk UART_ALT_CTL_LIN_RX_EN_Msk (UART_ALT_CTL_LIN_TX_EN_Msk|UART_ALT_CTL_LIN_RX_EN_Msk)
  [in] | u32BreakLength | The breakfield length.

Returns
  None

The function is used to set LIN relative setting.

Definition at line 378 of file uart.c.

## ◆ UART_SelectRS485Mode()

void UART_SelectRS485Mode | ( | UART_T * | uart,
|  | uint32_t | u32Mode,
|  | uint32_t | u32Addr
| ) |  |

The function is used to set RS485 relative setting.

Parameters

  [in] | uart | The base address of UART module.
  [in] | u32Mode | The operation mode( UART_ALT_CTL_RS485_NMM_Msk / UART_ALT_CTL_RS485_AUD_Msk / UART_ALT_CTL_RS485_AAD_Msk).
  [in] | u32Addr | The RS485 address.

Returns
  None

Definition at line 357 of file uart.c.

## ◆ UART_SET_RTS()

static __INLINE void UART_SET_RTS | ( | UART_T * | uart | ) |
| static

Set RTS pin is high.

Parameters

  [in] | uart | The base address of UART module

Returns
  None

Definition at line 321 of file uart.h.

## ◆ UART_SetLine_Config()

void UART_SetLine_Config | ( | UART_T * | uart,
|  | uint32_t | u32baudrate,
|  | uint32_t | u32data_width,
|  | uint32_t | u32parity,
|  | uint32_t | u32stop_bits
| ) |  |

This function use to config UART line setting.

Parameters

  [in] | uart | The base address of UART module.
  [in] | u32baudrate | The register value of baudrate of UART module. if u32baudrate = 0, UART baudrate will not change.
  [in] | u32data_width | The data length of UART module.
  [in] | u32parity | The parity setting (odd/even/none) of UART module.
  [in] | u32stop_bits | The stop bit length (1/1.5 bit) of UART module.

Returns
  None

Definition at line 256 of file uart.c.

Here is the call graph for this function:

## ◆ UART_SetTimeoutCnt()

void UART_SetTimeoutCnt | ( | UART_T * | uart,
|  | uint32_t | u32TOC
| ) |  |

This function use to set Rx timeout count.

Parameters

  [in] | uart | The base address of UART module.
  [in] | u32TOC | Rx timeout counter.

Returns
  None

Definition at line 301 of file uart.c.

## ◆ UART_Write()

uint32_t UART_Write | ( | UART_T * | uart,
|  | uint8_t * | pu8TxBuf,
|  | uint32_t | u32WriteBytes
| ) |  |

The function is to write data into TX buffer to transmit data by UART.

Parameters

  [in] | uart | The base address of UART module.
  [in] | pu8TxBuf | The buffer to send the data to UART transmission FIFO.
  [in] | u32WriteBytes | The byte number of data.

Returns
  u32Count: transfer byte count

Definition at line 399 of file uart.c.